`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2019/03/08 00:33:50
// Design Name: 
// Module Name: scan_freq_ctl
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////

module scan_freq_ctl(
    ssd_in,
    ssd_ctl,
    clk_ctl_en,
    rst_n,
    volume_level
);
    output reg [3:0] ssd_ctl;
    output reg [3:0] ssd_in;
    input [1:0] clk_ctl_en;
    input rst_n;
    input [3:0] volume_level;
    
    reg [3:0] in_0;
    reg [3:0] in_1;

    always @*
      if (volume_level <= 9)
        begin
          in_0 = volume_level;
          in_1 = 4'd0;
        end
      else
        begin
          in_0 = volume_level - 4'd10;
          in_1 = 4'd1;
        end


    always @*
    begin
      if (~rst_n)
        begin
        ssd_ctl = 4'b1111;
        ssd_in = 4'b1111;
        end
      else
        begin
        case (clk_ctl_en)
          2'b00:
            begin
                ssd_ctl = 4'b1111;
                ssd_in = 4'b0000;
            end
          2'b01:
            begin
                ssd_ctl = 4'b1111;
                ssd_in = 4'b0000;
            end
          2'b10:
            begin
                ssd_ctl = 4'b1101;
                ssd_in = in_1;
            end        
          2'b11:
            begin
                ssd_ctl = 4'b1110;
                ssd_in = in_0;
            end
          default:
            begin
                ssd_ctl = 4'b0000;
                ssd_in = 4'b0000;
            end
            
        endcase
        end 
      end      
endmodule
